"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findNodeModulesMirrorfulPath = void 0;
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
function findNodeModulesMirrorfulPath() {
    // Get the current working directory
    const cwd = process.cwd();
    // Traverse up the directory tree until we find the node_modules directory
    let dir = cwd;
    while (dir !== path_1.default.parse(dir).root) {
        const nodeModulesDir = path_1.default.join(dir, 'node_modules/mirrorful');
        const testNodeModulesDir = path_1.default.join(dir, 'node_modules/@mirrorful/test');
        if (fs_1.default.existsSync(nodeModulesDir)) {
            return nodeModulesDir;
        }
        if (fs_1.default.existsSync(testNodeModulesDir)) {
            return testNodeModulesDir;
        }
        dir = path_1.default.dirname(dir);
    }
    // If we reached the root directory without finding node_modules, throw an error
    if (dir === path_1.default.parse(dir).root) {
        throw Error(`Could not find node_modules directory in: ${cwd} or its parent directories`);
    }
}
exports.findNodeModulesMirrorfulPath = findNodeModulesMirrorfulPath;
