"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOnline = void 0;
const child_process_1 = require("child_process");
const dns_1 = __importDefault(require("dns"));
const url_1 = __importDefault(require("url"));
function getProxy() {
    if (process.env.https_proxy) {
        return process.env.https_proxy;
    }
    try {
        const httpsProxy = (0, child_process_1.execSync)('npm config get https-proxy').toString().trim();
        return httpsProxy !== 'null' ? httpsProxy : undefined;
    }
    catch (e) {
        return;
    }
}
function getOnline() {
    return new Promise((resolve) => {
        dns_1.default.lookup('registry.yarnpkg.com', (registryErr) => {
            if (!registryErr) {
                return resolve(true);
            }
            const proxy = getProxy();
            if (!proxy) {
                return resolve(false);
            }
            const { hostname } = url_1.default.parse(proxy);
            if (!hostname) {
                return resolve(false);
            }
            dns_1.default.lookup(hostname, (proxyErr) => {
                resolve(proxyErr == null);
            });
        });
    });
}
exports.getOnline = getOnline;
