"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
const open_1 = __importDefault(require("open"));
const sleep_1 = __importDefault(require("./sleep"));
function openBrowser({ url, port }) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield waitToOpenBrowser(port);
            yield (0, open_1.default)(`${url}:${port}`);
        }
        catch (error) {
            console.log(`Visit: ${chalk_1.default.green(`${`http://localhost:`}${port.toString()}`)} to open Mirrorful. Could not open automatically.`);
        }
    });
}
exports.default = openBrowser;
function waitToOpenBrowser(port) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log(`✨ Opening Mirrorful in your browser at ${chalk_1.default.cyan(`${`http://localhost:`}${port.toString()}`)}`);
        console.log();
        yield (0, sleep_1.default)(5000);
    });
}
