"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.packageLibrary = void 0;
const child_process_1 = require("child_process");
const fs_1 = __importDefault(require("fs"));
const chalk_1 = __importDefault(require("chalk"));
const logProgress = (message) => {
    console.log(chalk_1.default.cyan(message));
};
function packageLibrary() {
    return __awaiter(this, void 0, void 0, function* () {
        logProgress('Compiling library...');
        (0, child_process_1.execSync)(`npx vite build --config ${__dirname}/vite-lib.config.js`);
        logProgress('Forming dist...');
        // Create final dist folder
        fs_1.default.mkdirSync(`${__dirname}/dist`, { recursive: true });
        fs_1.default.cpSync(`${__dirname}/module/library.es.js`, `${__dirname}/dist/library.es.js`);
        const files = fs_1.default
            .readdirSync(`${__dirname}/module/build/_assets`)
            .filter((fileName) => fileName.startsWith('tailwind'))
            .filter((fileName) => fileName.endsWith('.css'));
        fs_1.default.cpSync(`${__dirname}/module/build/_assets/${files[0]}`, `${__dirname}/dist/main.css`);
        fs_1.default.rmdirSync(`${__dirname}/module`, { recursive: true });
        logProgress('Forming package.json...');
        // TODO: Generate a package json to put inside of dist
        logProgress('Syncing files...');
        // TODO(Danilowicz): Upload files to S3
        // await createLibrary()
        logProgress('Publishing...');
        // TODO: Run npm publish INSIDE OF dist
    });
}
exports.packageLibrary = packageLibrary;
