"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const vite_1 = require("vite");
const node_path_1 = require("node:path");
const plugin_react_1 = __importDefault(require("@vitejs/plugin-react"));
const vite_plugin_css_injected_by_js_1 = __importDefault(require("vite-plugin-css-injected-by-js"));
exports.default = (0, vite_1.defineConfig)(({ command, mode }) => __awaiter(void 0, void 0, void 0, function* () {
    console.log(__dirname);
    return {
        plugins: [
            (0, plugin_react_1.default)(),
            // dts({
            //   include: [`app/components/primitives`],
            // }),
            (0, vite_plugin_css_injected_by_js_1.default)(),
        ],
        build: {
            lib: {
                entry: (0, node_path_1.resolve)('./app/components/primitives/index.ts'),
                name: 'Library',
                formats: ['es'],
                fileName: (format) => `library.${format}.js`,
            },
            outDir: `${__dirname}/module`,
            emptyOutDir: true,
            minify: false,
            // rollupOptions: {
            //   external: ['react', 'react-dom'],
            //   output: {
            //     globals: {
            //       react: 'React',
            //       'react-dom': 'ReactDOM',
            //     },
            //   },
            // },
        },
        define: {
            'process.env.NODE_ENV': '"production"',
        },
        // resolve: {
        //   alias: {
        //     react: 'https://esm.sh/react@18.2.0?keep-names',
        //     'react-dom': 'https://esm.sh/react-dom@18.2.0?keep-names',
        //   },
        // },
    };
}));
