"use strict";
exports.id = 37;
exports.ids = [37];
exports.modules = {

/***/ 37862:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Units = exports.assertToken = exports.assertTokenGroup = exports.defaultConfigV2 = exports.defaultTypographyV2 = exports.defaultShadowsV2 = exports.defaultLineHeightsV2 = exports.defaultFontWeightsV2 = exports.defaultFontSizesV2 = exports.defaultColorsV2 = exports.defaultFiles = void 0;
exports.defaultFiles = [
    'css',
    'scss',
    'js',
    'cjs',
    'ts',
    'json',
];
// NEXT GENERATION DATA MODEL
// Migrating to standardized reference: https://design-tokens.github.io/
// This is empty so that users can sent through onboarding
exports.defaultColorsV2 = {};
exports.defaultFontSizesV2 = {
    sm: {
        id: 'default-font-size-sm-id',
        value: '1rem',
        type: 'fontSize',
    },
    md: {
        id: 'default-font-size-md-id',
        value: '1.2rem',
        type: 'fontSize',
    },
    lg: {
        id: 'default-font-size-lg-id',
        value: '1.4rem',
        type: 'fontSize',
    },
};
exports.defaultFontWeightsV2 = {
    light: {
        id: 'default-font-weight-light-id',
        value: '200',
        type: 'fontWeight',
    },
    normal: {
        id: 'default-font-weight-normal-id',
        value: '400',
        type: 'fontWeight',
    },
    bold: {
        id: 'default-font-weight-bold-id',
        value: '700',
        type: 'fontWeight',
    },
};
exports.defaultLineHeightsV2 = {
    short: {
        id: 'default-line-height-short-id',
        value: '1',
        type: 'lineHeight',
    },
    normal: {
        id: 'default-line-height-normal-id',
        value: '1.5',
        type: 'lineHeight',
    },
    tall: {
        id: 'default-line-height-tall-id',
        value: '2',
        type: 'lineHeight',
    },
};
exports.defaultShadowsV2 = {
    sm: {
        id: 'default-shadow-sm-id',
        value: '0 1px 2px 0 rgba(0, 0, 0, 0.05)',
        type: 'boxShadow',
    },
    md: {
        id: 'default-shadow-md-id',
        value: '0 1px 3px 0 rgba(0, 0, 0, 0.1), 0 1px 2px 0 rgba(0, 0, 0, 0.06)',
        type: 'boxShadow',
    },
    lg: {
        id: 'default-shadow-lg-id',
        value: '0 4px 6px -1px rgba(0, 0, 0, 0.1), 0 2px 4px -1px rgba(0, 0, 0, 0.06)',
        type: 'boxShadow',
    },
    'dark-lg': {
        id: 'default-shadow-dark-lg-id',
        value: '0 10px 15px -3px rgba(0, 0, 0, 0.1), 0 4px 6px -2px rgba(0, 0, 0, 0.05)',
        type: 'boxShadow',
    },
};
exports.defaultTypographyV2 = {
    fontSizes: exports.defaultFontSizesV2,
    fontWeights: exports.defaultFontWeightsV2,
    lineHeights: exports.defaultLineHeightsV2,
};
exports.defaultConfigV2 = {
    primitives: {
        colors: exports.defaultColorsV2,
        typography: exports.defaultTypographyV2,
        shadows: exports.defaultShadowsV2,
    },
    themes: [],
    files: exports.defaultFiles,
};
var assertTokenGroup = function (token) {
    return typeof token.id !== 'string';
};
exports.assertTokenGroup = assertTokenGroup;
var assertToken = function (token) {
    return typeof token.id === 'string';
};
exports.assertToken = assertToken;
exports.Units = ['px', 'rem', 'em', '%', 'number'];


/***/ }),

/***/ 6917:
/***/ ((module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.a(module, async (__webpack_handle_async_dependencies__, __webpack_async_result__) => { try {
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Gr": () => (/* binding */ ZeroPointZeroPointThreeMigration),
/* harmony export */   "QU": () => (/* binding */ ZeroPointZeroPointTwoMigration),
/* harmony export */   "Rw": () => (/* binding */ ZeroPointZeroSixMigration),
/* harmony export */   "kD": () => (/* binding */ ZeroPointZeroPointFourMigration),
/* harmony export */   "ol": () => (/* binding */ ZeroPointZeroFiveMigration)
/* harmony export */ });
/* harmony import */ var _mirrorful_core_lib_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(37862);
/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(46555);
var __webpack_async_dependencies__ = __webpack_handle_async_dependencies__([uuid__WEBPACK_IMPORTED_MODULE_1__]);
uuid__WEBPACK_IMPORTED_MODULE_1__ = (__webpack_async_dependencies__.then ? (await __webpack_async_dependencies__)() : __webpack_async_dependencies__)[0];


const ZeroPointZeroPointTwoMigration = (store)=>{
    const isNewData = store.get("primitives") !== undefined;
    if (isNewData) {
        return;
    }
    const tokens = store.get("tokens");
    const newTokens = {
        colorData: []
    };
    newTokens.colorData = tokens.colorData.map((color)=>{
        const variants = new Map();
        if (color.hover) {
            variants.set("Hover", color.hover);
        }
        if (color.active) {
            variants.set("Active", color.active);
        }
        if (color.shades) {
            variants.set("50", color.shades["50"]);
            variants.set("100", color.shades["100"]);
            variants.set("200", color.shades["200"]);
            variants.set("300", color.shades["300"]);
            variants.set("400", color.shades["400"]);
            variants.set("500", color.shades["500"]);
            variants.set("600", color.shades["600"]);
            variants.set("700", color.shades["700"]);
            variants.set("800", color.shades["800"]);
            variants.set("900", color.shades["900"]);
        }
        return {
            name: color.name,
            baseColor: color.base,
            variants: Object.fromEntries(variants)
        };
    });
    store.set("tokens", newTokens);
};
const ZeroPointZeroPointThreeMigration = (store)=>{
    const isNewData = store.get("primitives") !== undefined;
    if (isNewData) {
        return;
    }
    const tokens = store.get("tokens");
    const updatedTokens = {
        ...tokens
    };
    updatedTokens.typography = {};
    store.set("tokens", updatedTokens);
};
const ZeroPointZeroPointFourMigration = (store)=>{
    const isNewData = store.get("primitives") !== undefined;
    if (isNewData) {
        return;
    }
    store.set("files", _mirrorful_core_lib_types__WEBPACK_IMPORTED_MODULE_0__.defaultFiles);
};
const ZeroPointZeroFiveMigration = (store)=>{
    const isNewData = store.get("primitives") !== undefined;
    if (isNewData) {
        return;
    }
    const tokens = store.get("tokens");
    const updatedTokens = {
        ...tokens
    };
    updatedTokens.typography = {};
    store.set("tokens", updatedTokens);
};
const ZeroPointZeroSixMigration = (anyStore)=>{
    const isNewData = anyStore.get("primitives") !== undefined;
    if (isNewData) {
        return;
    }
    const store = anyStore;
    const tokens = store.get("tokens");
    const colors = {};
    tokens.colorData.forEach((color)=>{
        const currentColor = {};
        Object.keys(color.variants).forEach((variantName)=>{
            currentColor[variantName] = {
                id: (0,uuid__WEBPACK_IMPORTED_MODULE_1__.v4)(),
                value: color.variants[variantName],
                type: "color"
            };
        });
        if (color.baseColor) {
            currentColor.base = {
                id: (0,uuid__WEBPACK_IMPORTED_MODULE_1__.v4)(),
                value: color.baseColor,
                type: "color"
            };
        }
        colors[color.name] = currentColor;
    });
    const fontSizes = {};
    tokens.typography.fontSizes.forEach((variant)=>{
        fontSizes[variant.name] = {
            id: (0,uuid__WEBPACK_IMPORTED_MODULE_1__.v4)(),
            value: `${variant.value}${variant.unit}`,
            type: "fontSize"
        };
    });
    const fontWeights = {};
    tokens.typography.fontWeights.forEach((variant)=>{
        fontWeights[variant.name] = {
            id: (0,uuid__WEBPACK_IMPORTED_MODULE_1__.v4)(),
            value: variant.weight,
            type: "fontWeight"
        };
    });
    const lineHeights = {};
    tokens.typography.lineHeights.forEach((variant)=>{
        lineHeights[variant.name] = {
            id: (0,uuid__WEBPACK_IMPORTED_MODULE_1__.v4)(),
            value: `${variant.value}`,
            type: "fontWeight"
        };
    });
    const shadows = {};
    tokens.shadows.forEach((variant)=>{
        shadows[variant.name] = {
            id: (0,uuid__WEBPACK_IMPORTED_MODULE_1__.v4)(),
            value: variant.value,
            type: "boxShadow"
        };
    });
    const primitives = {
        colors,
        typography: {
            fontSizes,
            fontWeights,
            lineHeights
        },
        shadows
    };
    store.set("primitives", primitives);
    store.delete("tokens");
};

__webpack_async_result__();
} catch(e) { __webpack_async_result__(e); } });

/***/ }),

/***/ 18037:
/***/ ((module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.a(module, async (__webpack_handle_async_dependencies__, __webpack_async_result__) => { try {
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "h": () => (/* binding */ store),
/* harmony export */   "s": () => (/* binding */ rootPath)
/* harmony export */ });
/* harmony import */ var _mirrorful_core_lib_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(37862);
/* harmony import */ var conf__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(49242);
/* harmony import */ var conf__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(conf__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _migrations__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6917);
var __webpack_async_dependencies__ = __webpack_handle_async_dependencies__([_migrations__WEBPACK_IMPORTED_MODULE_2__]);
_migrations__WEBPACK_IMPORTED_MODULE_2__ = (__webpack_async_dependencies__.then ? (await __webpack_async_dependencies__)() : __webpack_async_dependencies__)[0];



// Our working directory is 2 levels below node_modules in production, so we go up 3 levels
const rootPath =  false ? 0 : "../../../.mirrorful";
const store = new (conf__WEBPACK_IMPORTED_MODULE_1___default())({
    projectName: "Mirrorful",
    projectVersion: "0.0.6",
    cwd: `${rootPath}/store`,
    defaults: _mirrorful_core_lib_types__WEBPACK_IMPORTED_MODULE_0__.defaultConfigV2,
    beforeEachMigration: (store, context)=>{
        console.log(`[main-config] migrate from ${context.fromVersion} → ${context.toVersion}`);
    },
    migrations: {
        "0.0.2": _migrations__WEBPACK_IMPORTED_MODULE_2__/* .ZeroPointZeroPointTwoMigration */ .QU,
        "0.0.3": _migrations__WEBPACK_IMPORTED_MODULE_2__/* .ZeroPointZeroPointThreeMigration */ .Gr,
        "0.0.4": _migrations__WEBPACK_IMPORTED_MODULE_2__/* .ZeroPointZeroPointFourMigration */ .kD,
        "0.0.5": _migrations__WEBPACK_IMPORTED_MODULE_2__/* .ZeroPointZeroFiveMigration */ .ol,
        "0.0.6": _migrations__WEBPACK_IMPORTED_MODULE_2__/* .ZeroPointZeroSixMigration */ .Rw
    }
});

__webpack_async_result__();
} catch(e) { __webpack_async_result__(e); } });

/***/ })

};
;