"use strict";
exports.id = 55;
exports.ids = [55];
exports.modules = {

/***/ 14055:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.handleInvalidColor = exports.defaultColorShadesToTokens = exports.generateDefaultColorShades = exports.newShade = void 0;
var tinycolor2_1 = __importDefault(__webpack_require__(1048));
var uuid_1 = __webpack_require__(25828);
var validCssColors_1 = __webpack_require__(39019);
/* eslint-disable @typescript-eslint/no-unused-expressions */
var newShade = function (hexColor, magnitude) {
    hexColor = hexColor.replace("#", "");
    if (hexColor.length === 6) {
        var decimalColor = parseInt(hexColor, 16);
        var r = (decimalColor >> 16) + magnitude;
        r > 255 && (r = 255);
        r < 0 && (r = 0);
        var g = (decimalColor & 0x0000ff) + magnitude;
        g > 255 && (g = 255);
        g < 0 && (g = 0);
        var b = ((decimalColor >> 8) & 0x00ff) + magnitude;
        b > 255 && (b = 255);
        b < 0 && (b = 0);
        return "#".concat((g | (b << 8) | (r << 16)).toString(16));
    }
    else {
        return hexColor;
    }
};
exports.newShade = newShade;
/* eslint-enable @typescript-eslint/no-unused-expressions */
var scaleDiff = 7;
var generateDefaultColorShades = function (primary) {
    return {
        50: (0, tinycolor2_1.default)(primary)
            .lighten(scaleDiff * 4.8)
            .toHexString(),
        100: (0, tinycolor2_1.default)(primary)
            .lighten(scaleDiff * 3.8)
            .toHexString(),
        200: (0, tinycolor2_1.default)(primary)
            .lighten(scaleDiff * 2.8)
            .toHexString(),
        300: (0, tinycolor2_1.default)(primary)
            .lighten(scaleDiff * 1.8)
            .toHexString(),
        400: (0, tinycolor2_1.default)(primary).lighten(scaleDiff).toHexString(),
        500: (0, tinycolor2_1.default)(primary).toHexString(),
        600: (0, tinycolor2_1.default)(primary).darken(scaleDiff).toHexString(),
        700: (0, tinycolor2_1.default)(primary)
            .darken(scaleDiff * 2.8)
            .toHexString(),
        800: (0, tinycolor2_1.default)(primary)
            .darken(scaleDiff * 3.8)
            .toHexString(),
        900: (0, tinycolor2_1.default)(primary)
            .darken(scaleDiff * 4.8)
            .toHexString(),
    };
};
exports.generateDefaultColorShades = generateDefaultColorShades;
var defaultColorShadesToTokens = function (shades) {
    return {
        50: {
            id: (0, uuid_1.v4)(),
            value: shades[50],
            type: 'color',
        },
        100: {
            id: (0, uuid_1.v4)(),
            value: shades[100],
            type: 'color',
        },
        200: {
            id: (0, uuid_1.v4)(),
            value: shades[200],
            type: 'color',
        },
        300: {
            id: (0, uuid_1.v4)(),
            value: shades[300],
            type: 'color',
        },
        400: {
            id: (0, uuid_1.v4)(),
            value: shades[400],
            type: 'color',
        },
        500: {
            id: (0, uuid_1.v4)(),
            value: shades[500],
            type: 'color',
        },
        600: {
            id: (0, uuid_1.v4)(),
            value: shades[600],
            type: 'color',
        },
        700: {
            id: (0, uuid_1.v4)(),
            value: shades[700],
            type: 'color',
        },
        800: {
            id: (0, uuid_1.v4)(),
            value: shades[800],
            type: 'color',
        },
        900: {
            id: (0, uuid_1.v4)(),
            value: shades[900],
            type: 'color',
        },
    };
};
exports.defaultColorShadesToTokens = defaultColorShadesToTokens;
var handleInvalidColor = function (input) {
    var sanitizedInput = input.replace(/ /g, '');
    // Check if input is a valid hex code
    var hexRegex = /^#?([0-9A-Fa-f]{3}|[0-9A-Fa-f]{6})$/;
    if (hexRegex.test(sanitizedInput)) {
        if (sanitizedInput.startsWith('#')) {
            return sanitizedInput;
        }
        else {
            return "#".concat(sanitizedInput);
        }
    }
    // Check if input is a valid rgb
    var rgbColorRegex = /rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/;
    if (rgbColorRegex.test(sanitizedInput)) {
        return sanitizedInput;
    }
    // Check if input is a valid color name
    var lowerCaseInput = sanitizedInput.toLowerCase();
    if (validCssColors_1.VALID_CSS_COLORS.includes(lowerCaseInput)) {
        return lowerCaseInput;
    }
    // Check if input is a valid subset of a hexcode
    var validSubsetRegex = /^#?[0-9A-Fa-f]{0,6}$/; // regex to validate if input is a valid subset of a hexcode
    var randomHex = '';
    for (var i = 0; i < 6; i++) {
        randomHex += Math.floor(Math.random() * 16).toString(16); // Generate six random hex digits.
    }
    if (validSubsetRegex.test(sanitizedInput)) {
        // check if input is a valid subset of a hexcode
        if (sanitizedInput.startsWith('#')) {
            return "".concat(sanitizedInput).concat(randomHex.slice(sanitizedInput.length - 1)); // use input as the first part and append random characters as necessary to make a valid hexcode
        }
        else {
            return "#".concat(sanitizedInput).concat(randomHex.slice(sanitizedInput.length)); // use input as the first part and append random characters as necessary to make a valid hexcode
        }
    }
    else {
        return "#".concat(randomHex); // generate a completely random valid hexcode
    }
};
exports.handleInvalidColor = handleInvalidColor;


/***/ }),

/***/ 39019:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.VALID_CSS_COLORS = void 0;
// Define a list of valid color names in CSS
exports.VALID_CSS_COLORS = [
    'aliceblue',
    'antiquewhite',
    'aqua',
    'aquamarine',
    'azure',
    'beige',
    'bisque',
    'black',
    'blanchedalmond',
    'blue',
    'blueviolet',
    'brown',
    'burlywood',
    'cadetblue',
    'chartreuse',
    'chocolate',
    'coral',
    'cornflowerblue',
    'cornsilk',
    'crimson',
    'cyan',
    'darkblue',
    'darkcyan',
    'darkgoldenrod',
    'darkgray',
    'darkgrey',
    'darkgreen',
    'darkkhaki',
    'darkmagenta',
    'darkolivegreen',
    'darkorange',
    'darkorchid',
    'darkred',
    'darksalmon',
    'darkseagreen',
    'darkslateblue',
    'darkslategray',
    'darkslategrey',
    'darkturquoise',
    'darkviolet',
    'deeppink',
    'deepskyblue',
    'dimgray',
    'dimgrey',
    'dodgerblue',
    'firebrick',
    'floralwhite',
    'forestgreen',
    'fuchsia',
    'gainsboro',
    'ghostwhite',
    'gold',
    'goldenrod',
    'gray',
    'grey',
    'green',
    'greenyellow',
    'honeydew',
    'hotpink',
    'indianred',
    'indigo',
    'ivory',
    'khaki',
    'lavender',
    'lavenderblush',
    'lawngreen',
    'lemonchiffon',
    'lightblue',
    'lightcoral',
    'lightcyan',
    'lightgoldenrodyellow',
    'lightgray',
    'lightgrey',
    'lightgreen',
    'lightpink',
    'lightsalmon',
    'lightseagreen',
    'lightskyblue',
    'lightslategray',
    'lightslategrey',
    'lightsteelblue',
    'lightyellow',
    'lime',
    'limegreen',
    'linen',
    'magenta',
    'maroon',
    'mediumaquamarine',
    'mediumblue',
    'mediumorchid',
    'mediumpurple',
    'mediumseagreen',
    'mediumslateblue',
    'mediumspringgreen',
    'mediumturquoise',
    'mediumvioletred',
    'midnightblue',
    'mintcream',
    'mistyrose',
    'moccasin',
    'navajowhite',
    'navy',
    'oldlace',
    'olive',
    'olivedrab',
    'orange',
    'orangered',
    'orchid',
    'palegoldenrod',
    'palegreen',
    'paleturquoise',
    'palevioletred',
    'papayawhip',
    'peachpuff',
    'peru',
    'pink',
    'plum',
    'powderblue',
    'purple',
    'rebeccapurple',
    'red',
    'rosybrown',
    'royalblue',
    'saddlebrown',
    'salmon',
    'sandybrown',
    'seashell',
    'sienna',
    'silver',
    'skyblue',
    'slateblue',
    'slategray',
    'slategrey',
    'snow',
    'springgreen',
    'steelblue',
    'tan',
    'teal',
    'thistle',
    'tomato',
    'turquoise',
    'violet',
    'wheat',
    'white',
    'whitesmoke',
    'yellow',
    'yellowgreen',
    'navyblue',
    'seagreen',
];


/***/ })

};
;