"use strict";
(() => {
var exports = {};
exports.id = 385;
exports.ids = [385];
exports.modules = {

/***/ 49242:
/***/ ((module) => {

module.exports = require("conf");

/***/ }),

/***/ 46555:
/***/ ((module) => {

module.exports = import("uuid");;

/***/ }),

/***/ 57147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 95795:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.createThemeObject = void 0;
var types_1 = __webpack_require__(37862);
var sanitizeName_1 = __webpack_require__(2778);
function createThemeObject(_a) {
    var primitives = _a.primitives, isTailwind = _a.isTailwind;
    var colors = primitives.colors, typography = primitives.typography, shadows = primitives.shadows;
    var themeObj = new Map();
    var colorObj = new Map();
    Object.keys(colors).forEach(function (colorName) {
        var color = colors[colorName];
        var currentColorObj = new Map();
        if ((0, types_1.assertTokenGroup)(color)) {
            Object.keys(color).forEach(function (variantName) {
                if (variantName === 'base' && isTailwind) {
                    currentColorObj.set('DEFAULT', "".concat(color[variantName].value));
                }
                else {
                    currentColorObj.set(variantName, "".concat(color[variantName].value));
                }
            });
        }
        colorObj.set((0, sanitizeName_1.sanitizeName)(colorName), Object.fromEntries(currentColorObj));
    });
    themeObj.set('colors', Object.fromEntries(colorObj));
    var fontSizeObj = new Map();
    Object.keys(typography.fontSizes).forEach(function (name) {
        var fontSize = typography.fontSizes[name];
        if ((0, types_1.assertToken)(fontSize)) {
            fontSizeObj.set((0, sanitizeName_1.sanitizeName)(name), "".concat(fontSize.value));
        }
    });
    themeObj.set('fontSizes', Object.fromEntries(fontSizeObj));
    var fontWeightObj = new Map();
    Object.keys(typography.fontWeights).forEach(function (name) {
        var fontWeight = typography.fontWeights[name];
        if ((0, types_1.assertToken)(fontWeight)) {
            fontWeightObj.set((0, sanitizeName_1.sanitizeName)(name), "".concat(fontWeight.value));
        }
    });
    themeObj.set('fontWeights', Object.fromEntries(fontWeightObj));
    var lineHeightObj = new Map();
    Object.keys(typography.lineHeights).forEach(function (name) {
        var lineHeight = typography.lineHeights[name];
        if ((0, types_1.assertToken)(lineHeight)) {
            lineHeightObj.set((0, sanitizeName_1.sanitizeName)(name), "".concat(lineHeight.value));
        }
    });
    themeObj.set('lineHeights', Object.fromEntries(lineHeightObj));
    var shadowsObj = new Map();
    Object.keys(shadows).forEach(function (name) {
        var shadow = shadows[name];
        if ((0, types_1.assertToken)(shadow)) {
            shadowsObj.set((0, sanitizeName_1.sanitizeName)(name), "".concat(shadow.value));
        }
    });
    themeObj.set('boxShadows', Object.fromEntries(fontSizeObj));
    var rawJsonObject = Object.fromEntries(themeObj);
    return rawJsonObject;
}
exports.createThemeObject = createThemeObject;


/***/ }),

/***/ 59794:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

var __webpack_unused_export__;

__webpack_unused_export__ = ({ value: true });
exports.L = void 0;
var toCjs_1 = __webpack_require__(32437);
var toCss_1 = __webpack_require__(64974);
var toJs_1 = __webpack_require__(20736);
var toJson_1 = __webpack_require__(45349);
var toScss_1 = __webpack_require__(32080);
var toTs_1 = __webpack_require__(16936);
exports.L = {
    css: {
        toContent: toCss_1.toCss,
        extension: '.css',
    },
    scss: {
        toContent: toScss_1.toScss,
        extension: '.scss',
    },
    js: {
        toContent: toJs_1.toJs,
        extension: '.js',
    },
    cjs: {
        toContent: toCjs_1.toCjs,
        extension: '_cjs.js',
    },
    ts: {
        toContent: toTs_1.toTs,
        extension: '.ts',
    },
    json: {
        toContent: toJson_1.toJson,
        extension: '.json',
    },
};


/***/ }),

/***/ 2778:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.sanitizeName = void 0;
function sanitizeName(name) {
    return "".concat(name).toLowerCase().split(' ').join('-');
}
exports.sanitizeName = sanitizeName;


/***/ }),

/***/ 32437:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.toCjs = void 0;
var json5_1 = __importDefault(__webpack_require__(40143));
var createThemeObject_1 = __webpack_require__(95795);
var toCjs = function (primitives) {
    var theme = (0, createThemeObject_1.createThemeObject)({ primitives: primitives });
    return 'exports.Tokens = ' + json5_1.default.stringify(theme, { space: 2 });
};
exports.toCjs = toCjs;


/***/ }),

/***/ 64974:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.toCss = void 0;
var types_1 = __webpack_require__(37862);
var sanitizeName_1 = __webpack_require__(2778);
var toCss = function (_a) {
    var colors = _a.colors, typography = _a.typography, shadows = _a.shadows;
    var content = [':root {'];
    Object.keys(colors).forEach(function (colorName) {
        var color = colors[colorName];
        if ((0, types_1.assertTokenGroup)(color)) {
            Object.keys(color).forEach(function (variantName) {
                content.push("  --color-".concat((0, sanitizeName_1.sanitizeName)(colorName), "-").concat((0, sanitizeName_1.sanitizeName)(variantName), ": ").concat(color[variantName].value, ";"));
            });
        }
    });
    Object.keys(typography.fontSizes).forEach(function (name) {
        var fontSize = typography.fontSizes[name];
        if ((0, types_1.assertToken)(fontSize)) {
            content.push("  --font-size-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(fontSize.value, ";"));
        }
    });
    Object.keys(typography.fontWeights).forEach(function (name) {
        var fontWeight = typography.fontWeights[name];
        if ((0, types_1.assertToken)(fontWeight)) {
            content.push("  --font-weight-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(fontWeight.value, ";"));
        }
    });
    Object.keys(typography.lineHeights).forEach(function (name) {
        var lineHeight = typography.lineHeights[name];
        if ((0, types_1.assertToken)(lineHeight)) {
            content.push("  --line-height-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(lineHeight.value, ";"));
        }
    });
    Object.keys(shadows).forEach(function (name) {
        var shadow = shadows[name];
        if ((0, types_1.assertToken)(shadow)) {
            content.push("  --box-shadow-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(shadow.value, ";"));
        }
    });
    content.push("}");
    return content.join('\n');
};
exports.toCss = toCss;


/***/ }),

/***/ 20736:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.toJs = void 0;
var json5_1 = __importDefault(__webpack_require__(40143));
var createThemeObject_1 = __webpack_require__(95795);
var toJs = function (primitives) {
    var theme = (0, createThemeObject_1.createThemeObject)({ primitives: primitives });
    return 'export const Tokens = ' + json5_1.default.stringify(theme, { space: 2 });
};
exports.toJs = toJs;


/***/ }),

/***/ 45349:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.toJson = void 0;
var json5_1 = __importDefault(__webpack_require__(40143));
var createThemeObject_1 = __webpack_require__(95795);
var toJson = function (primitives) {
    return json5_1.default.stringify((0, createThemeObject_1.createThemeObject)({ primitives: primitives }), null, 2);
};
exports.toJson = toJson;


/***/ }),

/***/ 32080:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.toScss = void 0;
var types_1 = __webpack_require__(37862);
var sanitizeName_1 = __webpack_require__(2778);
var toCss_1 = __webpack_require__(64974);
var toScss = function (primitives) {
    var colors = primitives.colors, typography = primitives.typography, shadows = primitives.shadows;
    var content = [];
    Object.keys(colors).forEach(function (colorName) {
        var color = colors[colorName];
        if ((0, types_1.assertTokenGroup)(color)) {
            Object.keys(color).forEach(function (variantName) {
                content.push("$color-".concat((0, sanitizeName_1.sanitizeName)(colorName), "-").concat((0, sanitizeName_1.sanitizeName)(variantName), ": ").concat(color[variantName].value, ";"));
            });
        }
    });
    Object.keys(typography.fontSizes).forEach(function (name) {
        var fontSize = typography.fontSizes[name];
        if ((0, types_1.assertToken)(fontSize)) {
            content.push("$font-size-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(fontSize.value, ";"));
        }
    });
    Object.keys(typography.fontWeights).forEach(function (name) {
        var fontWeight = typography.fontWeights[name];
        if ((0, types_1.assertToken)(fontWeight)) {
            content.push("$font-weight-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(fontWeight.value, ";"));
        }
    });
    Object.keys(typography.lineHeights).forEach(function (name) {
        var lineHeight = typography.lineHeights[name];
        if ((0, types_1.assertToken)(lineHeight)) {
            content.push("$line-height-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(lineHeight.value, ";"));
        }
    });
    Object.keys(shadows).forEach(function (name) {
        var shadow = shadows[name];
        if ((0, types_1.assertToken)(shadow)) {
            content.push("$box-shadow-".concat((0, sanitizeName_1.sanitizeName)(name), ": ").concat(shadow.value, ";"));
        }
    });
    content.push('', (0, toCss_1.toCss)(primitives));
    return content.join('\n');
};
exports.toScss = toScss;


/***/ }),

/***/ 16936:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.toTs = void 0;
var json5_1 = __importDefault(__webpack_require__(40143));
var createThemeObject_1 = __webpack_require__(95795);
var toTs = function (primitives) {
    var theme = (0, createThemeObject_1.createThemeObject)({ primitives: primitives });
    return "\n  export type Colors = keyof typeof Tokens.colors\n  export type FontSize = keyof typeof Tokens.fontSizes\n  export type Shadows = keyof typeof Tokens.boxShadows\n\n  export type Token = Colors | FontSize | Shadows\n\n  export const Tokens = ".concat(json5_1.default.stringify(theme, { space: 2 }), "\n  ");
};
exports.toTs = toTs;


/***/ }),

/***/ 61947:
/***/ ((module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.a(module, async (__webpack_handle_async_dependencies__, __webpack_async_result__) => { try {
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _mirrorful_core_lib_translators__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(59794);
/* harmony import */ var fs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(57147);
/* harmony import */ var fs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(fs__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _store_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(18037);
var __webpack_async_dependencies__ = __webpack_handle_async_dependencies__([_store_store__WEBPACK_IMPORTED_MODULE_2__]);
_store_store__WEBPACK_IMPORTED_MODULE_2__ = (__webpack_async_dependencies__.then ? (await __webpack_async_dependencies__)() : __webpack_async_dependencies__)[0];



const generateStorageFile = async ({ primitives , files  })=>{
    _store_store__WEBPACK_IMPORTED_MODULE_2__/* .store.set */ .h.set("primitives", primitives);
    _store_store__WEBPACK_IMPORTED_MODULE_2__/* .store.set */ .h.set("files", files);
};
async function handler(req, res) {
    const config = JSON.parse(req.body)// TODO: Validate request body
    ;
    await generateStorageFile(config);
    for (const fileType of config.files){
        const translator = _mirrorful_core_lib_translators__WEBPACK_IMPORTED_MODULE_0__/* .translators */ .L[fileType];
        const fileName = `${_store_store__WEBPACK_IMPORTED_MODULE_2__/* .rootPath */ .s}/theme${translator.extension}`;
        const content = translator.toContent(config.primitives);
        fs__WEBPACK_IMPORTED_MODULE_1___default().writeFileSync(fileName, content);
    }
    return res.status(200).json({
        message: "Success"
    });
}

__webpack_async_result__();
} catch(e) { __webpack_async_result__(e); } });

/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [143,37], () => (__webpack_exec__(61947)));
module.exports = __webpack_exports__;

})();